#!/bin/bash

# Runs the CR tool on the output of K-B and generates
# the results before and after it.

echo "Before running this file, remember to change the 'path' in the crtool.pl file!"

cat kb_output.txt | ../addnumb_coref.pl | ../../../crtool.pl -sfn | sed 's/^[0-9]\+ //' | grep -v "^$" > output_kb_coref.txt
cat output_kb_coref.txt | ../ner2bio.pl | sed 's/^O #/#/' | grep -v "<SENT>" > output_kb_coref_IOB.txt
cat kb_output.txt | ../ner2bio.pl | sed 's/^O #/#/' | grep -v "<SENT>" > output_kb_IOB.txt
cat output_kb_coref_IOB.txt | cut -d " " -f 1 > out_coref
cat gold_nospace_IOB.txt | awk 'FS=" " {print $2,$1}' > out_gold
paste out_gold out_coref | sed 's/\t/ /g' > eval_coref.txt
echo "Results without CR tool:"
cat output_kb_IOB.txt | cut -d " " -f 1 > out_fl
paste out_gold out_fl | sed 's/\t/ /g' > eval_kb.txt
perl ../conlleval.pl < eval_kb.txt
echo "Results with CR tool:"
perl ../conlleval.pl < eval_coref.txt

