#!/usr/bin/perl

# Takes as input a labeled corpus (FreeLing) and modifies the NP tokenization to IOB format:
# Partido_Democrata_Galego partido_democrata_galego NP00000
# B Partido partido NCMS000 / I Democrata democrata AQ0CS0 / I Galego galego AQ0MS0

while ($line = <STDIN>) {
    chomp($line);
    
    if ($line ne "") {
	($token, $lemma, $tag) = split(" ", $line);
	
	if ($tag =~ /^NP00S/ && $token =~ /_/) {
	    (@toks) = split("_", $token);
	    (@lems) = split("_", $lemma);
	    
	    for ($i=0; $i<= $#toks; $i++) {
		if ($i==0) {
		    print "B-PER $toks[0] $lems[0] $tag\n";
		} else {
		    print "I-PER $toks[$i] $lems[$i] $tag\n";
		}
	    }
	} elsif ($tag =~ /^NP00G/ && $token =~ /_/) {
	    (@toks) = split("_", $token);
	    (@lems) = split("_", $lemma);
	    
	    for ($i=0; $i<= $#toks; $i++) {
		if ($i==0) {
		    print "B-LOC $toks[0] $lems[0] $tag\n";
		} else {
		    print "I-LOC $toks[$i] $lems[$i] $tag\n";
		}
	    }
	} elsif ($tag =~ /^NP00O/ && $token =~ /_/) {
	    (@toks) = split("_", $token);
	    (@lems) = split("_", $lemma);
	    
	    for ($i=0; $i<= $#toks; $i++) {
		if ($i==0) {
		    print "B-RG $toks[0] $lems[0] $tag\n";
		} else {
		    print "I-RG $toks[$i] $lems[$i] $tag\n";
		}
	    }
	} elsif ($tag =~ /^NP00V/ && $token =~ /_/) {
	    (@toks) = split("_", $token);
	    (@lems) = split("_", $lemma);
	    
	    for ($i=0; $i<= $#toks; $i++) {
		if ($i==0) {
		    print "B-MISC $toks[0] $lems[0] $tag\n";
		} else {
		    print "I-MISC $toks[$i] $lems[$i] $tag\n";
		}
	    }
	} elsif ($token =~ /_/) {
	    (@toks) = split("_", $token);
	    (@lems) = split("_", $lemma);
	    
	    for ($i=0; $i<= $#toks; $i++) {
		if ($i==0) {
		    print "O $toks[0] $lems[0] $tag\n";
		} else {
		    print "O $toks[$i] $lems[$i] $tag\n";
		}
	    }
	} elsif ($tag =~ /^NP00S/) {
	    print "B-PER $token $lemma $tag\n";
	} elsif ($tag =~ /^NP00G/) {
	    print "B-LOC $token $lemma $tag\n";
	} elsif ($tag =~ /^NP00O/) {
	    print "B-RG $token $lemma $tag\n";
	} elsif ($tag =~ /^NP00V/) {
	    print "B-MISC $token $lemma $tag\n";
	} elsif ($token =~ /[.:;]/) {
	    print "O $line\n<SENT>\n";
	} else {
	    print "O $line\n";
	}
    }
}
