# This file contains some generic
# functions used by crtool.pl
#################################

# Merge Gender
##############
sub MergeGender {

    my ($m, $i) = @_;
    
    if ($Gender{$i} =~ /^(F|M)/ && $Gender{$m} !~ /^(F|M)/) {
	$GenderEnt{$id_entity} = $Gender{$i};
    } else {
	$GenderEnt{$id_entity} = $Gender{$m};
    }
}

# Merge Entities 1
##################
sub Merge {

    my ($Mentions, $m, $i) = @_;
    my %Mentions = %$Mentions;
    # New ID (both mentions without entity)
    if ($Mentions{$m} eq "X" && $Mentions{$i} eq "X") {
	$id_entity++;

	$Mentions{$m} = $id_entity;
	$Mentions{$i} = $id_entity;
	push(@$id_entity, $m);
	push(@$id_entity, $i);

	MergeGender($m, $i);

	push(@{$FullNPEnt{$id_entity}}, $FullNP{$m});
	push(@{$FullNPEnt{$id_entity}}, $FullNP{$i});
    } else {
	# One of them doesn't have entity
	if ($Mentions{$m} eq "X") {
	    my $new_id = $Mentions{$i};
	    $Mentions{$m} = $new_id;
	    push(@$new_id, $m);

	    MergeGender($m, $i);
	    
	    push(@{$FullNPEnt{$new_id}}, $FullNP{$m});
	    push(@{$FullNPEnt{$new_id}}, $FullNP{$i});
	} elsif ($Mentions{$i} eq "X") {
	    my $new_id = $Mentions{$m};
	    $Mentions{$i} = $new_id;
	    push(@$new_id, $i);

	    MergeGender($m, $i);

	    push(@{$FullNPEnt{$new_id}}, $FullNP{$m});
	    push(@{$FullNPEnt{$new_id}}, $FullNP{$i});    
	}
	# Both mentions have ID: chose the lower one
	else {
	    if ($Mentions{$m} > $Mentions{$i}) {
		$new_id = $Mentions{$i};
		$old_id = $Mentions{$m};
		$Mentions{$m} = $new_id;
	    } else {
		$new_id = $Mentions{$m};
		$old_id = $Mentions{$i};
		$Mentions{$i} = $new_id;
	    }
	    $Mentions_tmp = MergeEntities($new_id, $old_id, \%Mentions);
	    %Mentions = %$Mentions_tmp;
	}
    }

    # Sort the mentions in the entity array
    # (Only the first is chosen in further modules)
    foreach my $e(sort {my $a <=> my $b} values %Mentions) {
	if ($e ne "X") {
	    @$e = sort {$a <=> $b} (@$e);
	}
    }
    return \%Mentions;
}


# Merge Entities 2
##################
sub MergeEntities {

    my ($new_id, $old_id, $Mentions) = @_;
    my %Mentions = %$Mentions;
    my $Gender_tmp = ();

    # Verifies the features of each mention
    # Choose the gender and number of the new entity
    if (($Gender{$new_id} =~ /^M$/ && $Gender{$old_id} !~ /^M$/) || ($Gender{$old_id} =~ /^M$/ && $Gender{$new_id} !~ /^M$/)) {
	$Gender_tmp = "M";
	$GenderEnt{$new_id} = "M";
    } elsif (($Gender{$new_id} =~ /^F$/ && $Gender{$old_id} !~ /^F$/) || ($Gender{$old_id} =~ /^F$/ && $Gender{$new_id} !~ /^F$/)) {
	$Gender_tmp = "F";
	$GenderEnt{$new_id} = "F";
    }

    # Every mention of the entities are merged (same entity id)
    foreach my $m(sort {my $a <=> my $b} keys %Mentions) {
	if ($Mentions{$m} !~ /^X$/) {
	    if ($Mentions{$m} == $old_id) {
		$Mentions{$m} = $new_id;

		# Merge features
		# Gender
		if ($Gender_tmp) {
		    $Gender{$m} = $Gender_tmp;
		}
		# In HeadsNP and FullNP: pop the NPs from the old_id?
		#####################################################
		# HeadsNP
		if ($HeadNP{$m}) {
		    push(@{$HeadNPEnt{$new_id}}, $HeadNP{$m});
		}
		# FullNP
		if ($FullNP{$m}) {
		    push(@{$FullNPEnt{$new_id}}, $FullNP{$m});
		    push(@{$FullNPEnt{$new_id}}, $FullNP{$i});
		}
	    }
	}
    }
    # Entity features
    $GenderEnt{$new_id} = $Gender_tmp;
    return \%Mentions;
}


1;
