# This file contains some generic
# functions used by crtool.pl
#################################

# Mention Extraction
####################
sub MentionExtract{

    my %Input = @_;
    my $cont_line = 0;
    
    foreach my $linha(sort {$a <=> $b} keys %Input) {
	$cont_line++;

	if ($Input{$linha} =~ /^[0-9]/) {
	    (my $num_tok, my $token, my $lema, my $tag, my $coref) = split(" ", $Input{$linha});
	    
	    # Tokens in lower-case
	    $token = "\L$token";
	    
	    if ($coref ne "_") {

		# Single mentions
		if ($coref eq "(X)") {
		    $num_mention++;
		    $Mentions{$num_mention} = "X";
		    $MentionsForm{$num_mention} = $token;
		    $MentionsPos{$num_mention} = $cont_line;
		    $MentionsSent{$num_mention} = $num_sentence;
		    $MentionsTag{$num_mentions} = $tag;
		    $Tag{$num_mention} = $tag;
		    $Lema{$num_mention} = $lema;
		    $Head{$num_mention} = Head($token, $tag);
		    #if ($token || $tag =~ /^NP00SP0/) {
			$FullNP{$num_mention} = $token;
			#$HeadNP{$num_mention} = $HeadNP;
		    #}
		    if ($tag eq "NP00SP0") {
			$Gender{$num_mention} = ExtractFeats($linha, \%Input, $token); # ($Head{$num_mentions})
		    }
		}
	    }
	}
	# Extracts the number of the deppattern sentence (actually not a sentence)
	elsif ($Input{$linha} =~ /^\t$/ || $Input{$linha} =~ /^#end/) {
	    $num_sentence++;
	}
    }
    return %Input;
}

1;
